<?php


return  
    [
        'model' => [
            'model' => \Bixo\Location\Models\Building::class,
            'table' => 'bixo_location_buildings',
            'hidden'=> [],
            'visible' => [],
            'guarded' => ['*'],
            'slugs' => ['slug' => 'name'],
            'dates' => ['deleted_at', 'created_at', 'updated_at'],
            'appends' => [],
            'fillable' => ['country_id',  'region_id',  'location_id',  'sublocation_id',  'developer_id',  'type',  'name',  'name_portals',  'address',  'specifications',  'photos',  'floor_plans',  'latitude',  'longitude',  'min_price',  'max_price'],
            'translatables' => [],
            'upload_folder' => 'location/building',
            'uploads' => [
            /*
                    'images' => [
                        'count' => 10,
                        'type'  => 'image',
                    ],
                    'file' => [
                        'count' => 1,
                        'type'  => 'file',
                    ],
            */
            ],

            'casts' => [
             
                'marking'    => 'array',
            
            /*
                'images'    => 'array',
                'file'      => 'array',
            */
            ],

            'revision' => [],
            'perPage' => '20',
            'search'        => [
                'name'  => 'like',
                'status',
            ]
        ],

        'search' => [
            
        ],

        'list' => [
            [
                "key" => "country_id", 
                "type" => "text", 
                "label" => 'location::building.label.country_id', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "region_id", 
                "type" => "text", 
                "label" => 'location::building.label.region_id', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "location_id", 
                "type" => "text", 
                "label" => 'location::building.label.location_id', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "sublocation_id", 
                "type" => "text", 
                "label" => 'location::building.label.sublocation_id', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "developer_id", 
                "type" => "text", 
                "label" => 'location::building.label.developer_id', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "type", 
                "type" => "text", 
                "label" => 'location::building.label.type', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "name", 
                "type" => "text", 
                "label" => 'location::building.label.name', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "name_portals", 
                "type" => "text", 
                "label" => 'location::building.label.name_portals', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "address", 
                "type" => "text", 
                "label" => 'location::building.label.address', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "specifications", 
                "type" => "text", 
                "label" => 'location::building.label.specifications', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "photos", 
                "type" => "text", 
                "label" => 'location::building.label.photos', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "floor_plans", 
                "type" => "text", 
                "label" => 'location::building.label.floor_plans', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "latitude", 
                "type" => "text", 
                "label" => 'location::building.label.latitude', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "longitude", 
                "type" => "text", 
                "label" => 'location::building.label.longitude', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "min_price", 
                "type" => "text", 
                "label" => 'location::building.label.min_price', 
                'sort' => true,
                'roles' => [],
            ],
            [
                "key" => "max_price", 
                "type" => "text", 
                "label" => 'location::building.label.max_price', 
                'sort' => true,
                'roles' => [],
            ],
        ],

        'form' => [
            [
                "key" => 'country_id',
                "element" => 'numeric',
                "type" => 'numeric',
                "label" => 'location::building.label.country_id',
                "placeholder" => 'location::building.placeholder.country_id',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'region_id',
                "element" => 'numeric',
                "type" => 'numeric',
                "label" => 'location::building.label.region_id',
                "placeholder" => 'location::building.placeholder.region_id',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'location_id',
                "element" => 'numeric',
                "type" => 'numeric',
                "label" => 'location::building.label.location_id',
                "placeholder" => 'location::building.placeholder.location_id',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'sublocation_id',
                "element" => 'numeric',
                "type" => 'numeric',
                "label" => 'location::building.label.sublocation_id',
                "placeholder" => 'location::building.placeholder.sublocation_id',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'developer_id',
                "element" => 'numeric',
                "type" => 'numeric',
                "label" => 'location::building.label.developer_id',
                "placeholder" => 'location::building.placeholder.developer_id',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'type',
                "element" => 'radios',
                "type" => 'radios',
                "label" => 'location::building.label.type',
                "placeholder" => 'location::building.placeholder.type',
                "rules" => '',
                "options" => function(){
                    return trans('location::building.options.type');
                },
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'name',
                "element" => 'text',
                "type" => 'text',
                "label" => 'location::building.label.name',
                "placeholder" => 'location::building.placeholder.name',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'name_portals',
                "element" => 'text',
                "type" => 'text',
                "label" => 'location::building.label.name_portals',
                "placeholder" => 'location::building.placeholder.name_portals',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'address',
                "element" => 'text',
                "type" => 'text',
                "label" => 'location::building.label.address',
                "placeholder" => 'location::building.placeholder.address',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'specifications',
                "element" => 'text',
                "type" => 'text',
                "label" => 'location::building.label.specifications',
                "placeholder" => 'location::building.placeholder.specifications',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'photos',
                "element" => 'text',
                "type" => 'text',
                "label" => 'location::building.label.photos',
                "placeholder" => 'location::building.placeholder.photos',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'floor_plans',
                "element" => 'text',
                "type" => 'text',
                "label" => 'location::building.label.floor_plans',
                "placeholder" => 'location::building.placeholder.floor_plans',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'latitude',
                "element" => 'text',
                "type" => 'text',
                "label" => 'location::building.label.latitude',
                "placeholder" => 'location::building.placeholder.latitude',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'longitude',
                "element" => 'text',
                "type" => 'text',
                "label" => 'location::building.label.longitude',
                "placeholder" => 'location::building.placeholder.longitude',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'min_price',
                "element" => 'numeric',
                "type" => 'numeric',
                "label" => 'location::building.label.min_price',
                "placeholder" => 'location::building.placeholder.min_price',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
            [
                "key" => 'max_price',
                "element" => 'numeric',
                "type" => 'numeric',
                "label" => 'location::building.label.max_price',
                "placeholder" => 'location::building.placeholder.max_price',
                "rules" => '',
                "group" => "main.main",
                "col" => "6",
                "append" => null,
                "prepend" => null,
                "roles" => [],
                "attributes" => [
                    'wrapper' => [],
                    "label" => [],
                    "element" => [],

                ],
            ],
        ],

        'urls' => [
            'new' => [
                'url' => 'location/building/new',
                'method' => 'GET',
            ],
            'create' => [
                'url' => 'location/building/create',
                'method' => 'GET',
            ],
            'store' => [
                'url' => 'location/building',
                'method' => 'POST',
            ],
            'update' => [
                'url' => 'location/building',
                'method' => 'PUT',
            ],
            'list' => [
                'url' => 'location/building',
                'method' => 'GET',
            ],
            'delete' => [
                'url' => 'location/building',
                'method' => 'DELETE',
            ],
        ],

        'order' => [
            'created_at' => 'location::building.label.created_at',
            'name' => 'location::building.label.name',
            'status' => 'location::building.label.status',
        ],

        'groups' => [
            [
                'icon' => "mdi:account-supervisor-outline",
                'name' => "location::building.groups.main",
                'group' => "main.main",
                'title' => "location::building.groups.main",
            ],
            [
                'icon' => "fe:home",
                'name' => "location::building.groups.details",
                'group' => "main.details",
                'title' => "location::building.groups.details",
            ],
            'images' => [
                'icon' => "fe:home",
                'name' => "location::building.groups.images",
                'group' => "main.images",
                'title' => "location::building.groups.images",
            ],
            'settings' => [
                'icon' => "fe:home",
                'name' => "location::building.groups.settings",
                'group' => "main.settings",
                'title' => "location::building.groups.settings",
            ]
        ],

        'controller' => [
            'provider' => 'Bixo',
            'package' => 'Location',
            'module' => 'Building',
        ],

         
        'workflow' => [
            'type' => 'workflow',
            'marking_store' => [
                'type' => 'multiple_state',
                'arguments' => ['status'],
                // 'property' => 'status'
            ],
            'supports' => [
                \Bixo\Location\Models\Building::class,
            ],
            'places' => [
                'Draft',
                'Pending',
                'Approved',
                'Closed',
                'Published',
                'Archived',
                'Unpublished',
            ],
            'initial_places' => ['Draft'],
            'transitions' => [
                'submit' => [
                    'from' => 'Draft',
                    'to' => 'Pending',
                    'metadata' => [
                        'roles' => [
                            'user' => ['*'],
                        ],
                        'rules' => [
                            'name' => 'required',
                        ]
                    ],
                ],
                'reject' => [
                    'from' => 'Pending',
                    'to' => 'Draft',
                    'metadata' => [
                        'roles' => [
                            'user' => ['superuser'],
                            'team' => ['admin', 'manager'],
                        ],
                        'form' => [
                            'title' => 'Reject',
                            'button' => [
                                'cancel' > [
                                    'icon' > '',
                                    'varient' > '',
                                    'label' > 'Cancel'
                                ],
                                'submit' > [
                                    'icon' > '',
                                    'varient' > 'primary',
                                    'label' > 'Reject'
                                ]
                            ],
                            'fields' => [
                                'count' => [
                                    "element" => 'select',
                                    "type" => 'select',
                                    "label" => 'advert::advert.label.count',
                                    "placeholder" => 'advert::advert.placeholder.count',
                                    "options" => call_user_func(function () {
                                        return [
                                            1 => ['value' => 1, 'text' => 1],
                                            2 => ['value' => 2, 'text' => 2],
                                            3 => ['value' => 3, 'text' => 3],
                                            4 => ['value' => 4, 'text' => 4],
                                        ];
                                    }),
                                    "col" => "12",
                                ],
                                'comment' => [
                                    "element" => 'textarea',
                                    "type" => 'text',
                                    "required" => 'required',
                                    "label" => 'advert::advert.label.comment',
                                    "placeholder" => 'advert::advert.placeholder.comment',
                                    "col" => "12",
                                ],
                            ],
                        ],
                    ],
                ],
                'approve' => [
                    'from' => 'Pending',
                    'to' => 'Approved',
                    'metadata' => [
                        'roles' => [
                            'user' => ['superuser'],
                            'team' => ['admin', 'manager'],
                        ]
                    ],
                ],
                'publish' => [
                    'from' => ['Approved', 'Unpublished'],
                    'to' => 'Published',
                    'metadata' => [
                        'roles' => [
                            'user' => ['superuser'],
                            'team' => ['admin'],
                        ]
                    ],
                ],
                'unpublish' => [
                    'from' => ['Published'],
                    'to' => 'Unpublished',
                    'metadata' => [
                        'roles' => [
                            'user' => ['superuser', 'admin'],
                            'team' => ['admin'],
                        ]
                    ],
                ],
                'archive' => [
                    'from' => ['Published', 'Unpublished'],
                    'to' => 'Archived',
                    'metadata' => [
                        'roles' => [
                            'user' => ['superuser', 'admin'],
                            'team' => ['admin'],
                        ]
                    ],
                ],
                'unarchive' => [
                    'from' => ['Archived'],
                    'to' => 'Draft',
                    'metadata' => [
                        'roles' => [
                            'user' => ['superuser', 'admin'],
                            'team' => ['admin'],
                        ]
                    ],
                ],
            ],
        ],
        
         
        'actions' => [
            'copy' => [
                'type' => ['Details', 'List'],
                'label' => 'location::building.action.copy',
                'roles' => [
                    'user' => ['superuser', 'admin'],
                    'team' => ['admin'],
                    'permission' => ['location.building.copy', 'location.building.duplicate'],
                ],
                'form' => [
                    'count' => [
                        "element" => 'select',
                        "type" => 'select',
                        "label" => 'location::building.label.count',
                        "placeholder" => 'location::building.placeholder.count',
                        "options" => call_user_func(function () {
                            return [
                                1 => ['value' => 1, 'text' => 1],
                                2 => ['value' => 2, 'text' => 2],
                                3 => ['value' => 3, 'text' => 3],
                                4 => ['value' => 4, 'text' => 4],
                            ];
                        }),
                        "col" => "12",
                    ],
                    'comment' => [
                        "element" => 'textarea',
                        "type" => 'text',
                        "required" => 'required',
                        "label" => 'location::building.label.comment',
                        "placeholder" => 'location::building.placeholder.comment',
                        "col" => "12",
                    ],
                ],
            ],
            'empty' => [
                'type' => ['List', 'Details'],
                'label' => 'location::building.action.empty',
                'roles' => [
                    'user' => ['superuser'],
                ],
            ],
            
            'section' => [
                'type' => ['Group'],
                'api_url' => '',
                'action' => 'list',
                'label' => 'location::building.action.section',
                'store' => 'main.units',
                'group' => 'main.units'
            ],

        ]
        
    ];
