<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;

class CreateBixoLocationBuildingsTable extends Migration
{
    /*
     * Run the migrations.
     *
     * @return void
     */

    public function up()
    {

        /*
         * Table: bixo_location_buildings
         */
        Schema::create('bixo_location_buildings', function ($table) {
            $table->increments('id');
            $table->integer('country_id')->nullable();
            $table->integer('region_id')->nullable();
            $table->integer('location_id')->nullable();
            $table->integer('sublocation_id')->nullable();
            $table->integer('developer_id')->nullable();
            $table->enum('type', ['Yes', 'No'])->nullable();
            $table->string('name', 255)->nullable();
            $table->text('name_portals')->nullable();
            $table->string('slug', 100)->nullable();
            $table->string('address', 350)->nullable();
            $table->text('specifications')->nullable();
            $table->text('photos')->nullable();
            $table->text('floor_plans')->nullable();
            $table->string('latitude', 20)->nullable();
            $table->string('longitude', 20)->nullable();
            $table->integer('min_price')->nullable();
            $table->integer('max_price')->nullable();
            $table->string('upload_folder', 150)->nullable();
            $table->text('marking', 200)->nullable();
            $table->softDeletes();
            $table->nullableTimestamps();
        });
    }

    /*
    * Reverse the migrations.
    *
    * @return void
    */

    public function down()
    {
        Schema::drop('bixo_location_buildings');
    }
}
